<?php
// $Id: views_service.inc,v 1.1.2.9 2008/09/01 19:40:15 brmassa Exp $
/**
 * @author Steven Merrill
 * @file
 *  Link general views functionalities to services module.
 */

/**
 * Get a view from the database.
 *
 * @param $view_name
 *   String. The views name.
 * @param $display_id
 *   String (optional).
 * @param $args
 *   Array (optional). A list of params.
 * @return
 *   Array. The views return.
 */
function views2_service_get($view_name, $fields = array(), $args = array(), $offset = 0, $limit = 0, $display_id = NULL) {
  $view = views_get_view($view_name);

  // Put all arguments and then execute
  //$view->set_arguments($args, FALSE);
  $view->set_offset($offset);
  $view->set_items_per_page($limit);

  if ($display_id == NULL) {
    foreach ($view->display as $id => $display) {
      if ($display->display_plugin == 'views2_service_feed') {
        $display_id = $id;
        break;
      }
    }
  }
  
  return $view->execute_display($display_id, $args);
}

/**
 * Check the access permission to a given views.
 *
 * @param view_name
 *   String. The views name.
 * @return
 *   Boolean. TRUE if the user is allowed to load the given view.
 */
function views2_service_get_access($view_name) {
  $view = views_get_view($view_name);
  if (empty($view)) {
    return FALSE;
  }

  global $user;
  return views_access($view);
}
